include \masm32\include\masm32rt.inc

EolMode	equ 13, 10
; EolMode	equ 32,32,32,32		; for horizontal display

mbDebug MACRO txt_title,args:VARARG
LOCAL mbDebugbptr
 pushad
 pushfd
 ifndef mbDebugbuff
	.data?
	mbDebugbuff	db 2048 dup (?)
	.data
	mbDebugbptr	dd mbDebugbuff
	mbDebugStop	dd IDOK
	.code
 endif
 mov edx, OFFSET mbDebugbuff
 mov mbDebugbptr, edx
 mov DWORD PTR [edx], 0
 for arg, <args>
	LOCAL tmp$, cc
	cc INSTR <arg>, <$>
	pushad
	tmp$ CATSTR <chr$(">, <arg>, <")>
	if cc
		mov mbDebugbptr, cat$(mbDebugbptr, tmp$, chr$(9), <arg>, chr$(EolMode))
	else
		mov mbDebugbptr, cat$(mbDebugbptr, tmp$, chr$(9), sstr$(arg), chr$(EolMode))
	endif
	popad
 ENDM
 .if mbDebugStop==IDOK
	invoke MessageBox, 0, addr mbDebugbuff, reparg(txt_title), MB_OKCANCEL
 .endif
 mov mbDebugStop, eax
 popfd
 popad
ENDM

.code

txMyPath	db "MulDbgMacro.asm", 0
txMyGreets	db "Still no horizontal display for Hutch!", 13,10, 13,10
	db "Apologies that we cannot show edx - ", 13,10
	db "we had to use at least one register...", 0
MyFilePath$	dd txMyPath
MyGreets$	dd txMyGreets

start:

    call main
    exit

main proc
    LOCAL MyCounter:DWORD, My2ndVar:DWORD, MyThirdVar:DWORD
    mov MyCounter, 111
    mov My2ndVar, 222
    mov MyThirdVar, 333
    .While MyCounter>0
	pushad
	mov eax, 1000001
	mov ecx, 1000002
	mov edx, 1000003
	mov esi, 1000004
	mov edi, 1000005
	mov ebx, 1000006
	mbDebug "Show me the registers and five variables:", \
	eax, ecx, edx, esi, edi, ebx, ebp, esp, \
	MyCounter, MyThirdVar, MyFilePath$, MyGreets$
	dec MyCounter
	popad
    .Endw
    ret

main endp
end start
